
using System;
using System.Runtime.InteropServices;

// HUSB-DIO464 Driver I/F DLL Functions
// file name:hudio464.cs

public class Hudio464
{
	// ߂l
	public const uint NOT_FOUND = 0x1;
	public const uint ALREADY_OPENED = 0x2;
	public const uint NOT_MEMORY = 0x4;
	public const uint INVALID_HANDLE = 0x8;
	public const uint NOT_READY = 0x10;
    public const uint ILLEGAL_DEVICE = 0x20;
    public const uint ILLEGAL_ACCESS = 0x40;
    public const uint USB_TIMEOUT = 0x80;
	public const uint ILLEGAL_PARAM = 0x100;
	public const uint ILLEGAL_COMMAND = 0x200;
    public const uint ILLEGAL_RESPONSE = 0x400;

    // foCX
    [StructLayout(LayoutKind.Sequential)]
    public struct HUSBDEVINF
    {
        public ushort BrdID;	// {[hID( 0`15 )
        public ushort EPcnt;	// DIO464/v2:Gh|Cg(>=2)                   /DIO464U/T/W:1Œ
        public ushort EPspc0;	// DIO464/v2:Gh|Cgdl(0x81/0x02,0x02/0x86) /DIO464U/T/W:[0]COM߰ؽĲޯԍ(0`)@@@@@@@/
		public ushort EPspc1;
		public ushort EPspc2;
		public ushort EPspc3;
		public ushort EPspc4;
		public ushort EPspc5;
		public ushort EPspc6;
		public ushort EPspc7;
        public ushort EPsiz0;	// DIO464/v2:߲ĥ޲Đ(64/512,64/512)		/DIO464U/T/W:[0]COM|[gԍ(1`65535)
		public ushort EPsiz1;
		public ushort EPsiz2;
		public ushort EPsiz3;
		public ushort EPsiz4;
		public ushort EPsiz5;
		public ushort EPsiz6;
		public ushort EPsiz7;
        public ushort EPopt0;	// DIO464/v2:߲ĥ߼( \ )			    /DIO464U/T/W:0
		public ushort EPopt1;
		public ushort EPopt2;
		public ushort EPopt3;
		public ushort EPopt4;
		public ushort EPopt5;
		public ushort EPopt6;
		public ushort EPopt7;
        public IntPtr EPhdl0;   // DIO464/v2:߲ĥ(pCv)		    /DIO464U/T/W:[0]COM߰  
        public IntPtr EPhdl1;@
        public IntPtr EPhdl2;
        public IntPtr EPhdl3;
        public IntPtr EPhdl4;
        public IntPtr EPhdl5;
        public IntPtr EPhdl6;
        public IntPtr EPhdl7; 
    }

	// 1.foCX̎擾(FfoCX̌)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_GetDeviceCount(ref uint count);
    
	// 2.foCX̎擾(FfoCX̌AfoCX)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_GetDeviceInfo(ref uint count, [In, Out, MarshalAs(UnmanagedType.LPArray)] HUSBDEVINF[] HusbInf);
    
	// 3.foCXI[v(FfoCXnhAfoCX)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_OpenDevice(ref uint hDev, ref HUSBDEVINF HusbInf);
    
	// 4.foCXN[Y(FfoCXnh)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_CloseDevice(uint hDev);

    // 5.̓|[gPoCgǏo(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInB(uint hDev, ushort port, ref ushort wrdt);

	// 6.o̓|[gPoCgǏo(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutB(uint hDev, ushort port, ref ushort wrdt);

	// 7.o̓|[gPoCg(FfoCXnhA|[gԍAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutB(uint hDev, ushort port, ushort wwdt);

    // 8.̓|[gQoCgǏo(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInW(uint hDev, ushort port, ref ushort wwdt);

    // 9.o̓|[gQoCgǏo(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutW(uint hDev, ushort port, ref ushort wwdt);

	// 10.o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutW(uint hDev, ushort port, ushort wwdt);

    // 11.̓|[gSoCgǏo(FfoCXnhAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInDW(uint hDev, ref uint drdt);

    // 12.o̓|[gSoCgǏo(FfoCXnhAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutDW(uint hDev, ref uint drdt);

	// 13.o̓|[gSoCg(FfoCXnhAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutDW(uint hDev, uint dwdt);

    // 14.̓|[gSoCgǏoo̓|[gSoCg(FfoCXnhA̓f[^i[Ao̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_InOutDW(uint hDev, ref uint drdt, uint dwdt);

	// 15.tB^ݒ(FfoCXnhA|[gwATvO)
    //ii(DIO464/464v2)݊j
    [DllImport("Hudio464.dll")] 
	public static extern uint dio464_SetFilter(uint hDev, ushort port, uint wtm);

    // 16.tB^ݒ(FfoCXnhA|[gwAtB^[ԍ)
    //iVi(DIO464U/T/W)̂ݎgp\j
    [DllImport("Hudio464.dll")]
	public static extern uint dio464_SetFilterEx(uint hDev, ushort port, ushort fno);

    // 17.{[hŗLR[h(HEX4)̎擾(FfoCXnhAR[hi[)
	[DllImport("Hudio464.dll")]
	public static extern uint dio464_GetBoardCode(uint hDev, ref ushort code);

    // 18.{[h^Cv̎擾(FfoCXnhA^Cvi[)
	[DllImport("Hudio464.dll")]
	public static extern uint dio464_GetBoardType(uint hDev, ref ushort type);

    // 19.o[W擾(FfoCXnhAo[Wi[)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_rVersion(uint hDev, [MarshalAs(UnmanagedType.LPArray)] ushort[] ver);
    
    // 20.USBM(FfoCXnhAMf[^AMf[^)
	[DllImport("Hudio464.dll")]
	public static extern uint dio464_UsbSend(uint hDev, [MarshalAs(UnmanagedType.LPArray)] byte[] sdt, ref ushort size);
    
    // 21.USBM(FfoCXnhAf[^i[AMf[^)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_UsbRecv(uint hDev, [MarshalAs(UnmanagedType.LPArray)] byte[] rdt, ref ushort size);
}
 